routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\SingerController;
use App\Http\Controllers\SongController;
use App\Http\Controllers\AlbumController;
use App\Http\Controllers\UserController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::middleware('auth')->group(function () {
    Route::resource('category', CategoryController::class);
    Route::resource('singer', SingerController::class);
    Route::resource('song', SongController::class);
    Route::resource('album', AlbumController::class);
    Route::resource('users', UserController::class);
});


Route::get('/', function () {
    return view('home');
})->middleware(['auth'])->name('dashboard');
require __DIR__.'/auth.php';

app/Http/Controllers/SongController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\SongModel;
use App\Models\SingerModel;
use App\Models\CategoryModel;
use App\Models\AlbumModel;
use App\Models\CategorySongModel;
use App\Http\Requests\SongRequest;
use App\Models\AlbumSongModel;

class SongController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $songs = SongModel::with('categories', 'singers', 'albums')->paginate(6);
        return view('songs.songs',[
            'songs'=>$songs,
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $songs = SongModel::all();
        $albums = AlbumModel::all();
        $categories = CategoryModel::all();
        $singers = SingerModel::all();
        return view('songs.add', [
            'songs'=>$songs,
            'albums'=>$albums,
            'categories'=>$categories,
            'singers'=>$singers,
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(SongRequest $request)
    {
        $songs = SongModel::create([
            'name' => $request->input('name'),
            'singer_id'=>$request->input('singer_id'),
            'picture' => 'song_picture/'.$request->file_picture->getClientOriginalName(),
            'path' => 'songs/'.$request->file_song->getClientOriginalName(),
        ]);
        CategorySongModel::create([
            'song_id' => $songs->id,
            'category_id' => $request->category_id,
        ]);
        $songs->save();
        $request->file_picture->move("song_picture/", $request->file_picture->getClientOriginalName());
        $request->file_song->move("songs/", $request->file_song->getClientOriginalName());

        return redirect()->route('song.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $songs = SongModel::find($id);
        $songs->load('categories', 'singers', 'albums');
        $categories = CategoryModel::all();
        $singers = SingerModel::all();
        $albums = AlbumModel::all();
        return view('songs.edit', [
            'albums'=> $albums,
            'categories'=> $categories,
            'singers'=> $singers,
            'songs'=> $songs,
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(SongRequest $request, $id)
    {

        $songs = SongModel::where('id', $id)
            ->update([
                'name' => $request->input('name'),
                'singer_id'=>$request->input('singer_id'),
                'picture' => 'song_picture/'.$request->file_picture->getClientOriginalName(),
                'path' => 'songs/'.$request->file_song->getClientOriginalName(),
            ]);
        $cate_song = CategorySongModel::where('song_id', $id)
            ->update([
            'song_id' => $id,
            'category_id' => $request->category_id[0],
        ]);

        $request->file_picture->move("song_picture/", $request->file_picture->getClientOriginalName());
        $request->file_song->move("songs/", $request->file_song->getClientOriginalName());
        return redirect()->route('song.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $songs = SongModel::find($id);
        $songs->delete();
        return redirect()->route('song.index');
    }
}

resources/views/songs/add.blade.php
@extends('layouts.add')
@section('add')
    <div class="card-body">
        <form style="" class="row g-3 needs-validation"
        action="{{ route('song.store') }}" method="POST"
        enctype="multipart/form-data">
        @csrf
            {{-- <div class="col-12 mb-4">
                <div class="dropzone text-center">
                    <div class="dz-message">
                        <i class="ri-upload-cloud-2-line fs-2 text-dark"></i> <span class="d-block fs-6 mt-2">Drag & Drop or click to Upload</span>
                        <span class="d-block form-text mb-4">540x320 (Max: 300KB)</span> <button type="button" class="btn btn-light-primary">Upload cover image</button>
                    </div>
                </div>
            </div> --}}

            <div class="col-12 mb-4"><input type="text" class="form-control" placeholder="Song name" name="name" /></div>
            <div class="col-sm-6 mb-4">
                <label class="form-label">Picture</label>
                <input type="file"  name="file_picture" class="form-control">
            </div>

            <div class="col-sm-6 mb-4">
                <label class="form-label">Song file</label>
                <input type="file"  name="file_song" class="form-control">
            </div>

            <select  name="category_id" class="col-12 mb-4" style="background-color: #151719ed;" aria-label="Select category">
                <option selected="selected" disabled="disabled" hidden="">Select category</option>
                @foreach ($categories as $category)
                <option value="{{ $category->id }}">{{ $category->name }}</option>
                @endforeach
            </select>
            <select name="singer_id" class="form-select" style="background-color: #151719ed;" aria-label="Select category"><option selected="selected" disabled="disabled" hidden="">Select singer</option>
                @foreach ($singers as $singer)
                <option value="{{ $singer->id }}">{{ $singer->name }}</option>
                @endforeach
            </select>
            <div class="card-footer text-center"><button  type="submit" class="btn btn-primary" style="min-width: 140px;">ADD</button> </div>
        </form>
    </div>
@endsection

resources/views/songs/edit.blade.php
@extends('layouts.form')
@section('page_content')
    <div class="card-body">
        <form action="{{ route('song.update', $songs->id) }}" enctype="multipart/form-data" class="row" method="post">
            @csrf
            @method('PUT')
            <div class="col-12 mb-4">
                <input type="text" class="form-control" placeholder="Song name" name="name" value="{{ $songs->name }}" />
            </div>
            <div class="col-12 mb-4">
                <label class="form-label">Picture</label>
                <input type="file"  name="file_picture" class="form-control" value="{{ $songs->picture }}">
            </div>
            <div class="col-sm-6 mb-4">
                <label class="form-label">Song file</label>
                <input type="file"  name="file_song" class="form-control" value="{{ $songs->path }}">
            </div>
            <select  name="category_id[]" class="col-12 mt-4 select2-role" style="background-color: #151719ed;" multiple data-live-search="true">
                <option selected="selected" disabled="disabled" hidden=""></option>

                @foreach ($categories as $category)
                <option value="{{ $category->id }}">{{ $category->name }}</option>
                @endforeach


            </select>
            <select  name="singer_id" class="col-12 mb-4 select2-role"  aria-label="Select Singer">
                <option selected="selected" disabled="disabled" hidden="">Select Song</option>
                @foreach ($singers as $singer)
                <option value="{{ $singer->id }}">{{ $singer->name }}</option>
                @endforeach
            </select>
            <div class="card-footer text-center"><button  type="submit" class="btn btn-primary" style="min-width: 140px;">Edit</button> </div>
        </form>
    </div>
@endsection

resources/views/songs/songs.blade.php
@extends('layouts.form')
@section('page_content')
<div class="under-hero container">
    <div class="section">


    </div>
    <div class="section">
        <div class="section__head">
            <div class="flex-grow-1">
                <h3 class="mb-0">Free <span class="text-primary">Music</span></h3>
            </div>

        </div>
        <div class="list">
            <div class="row">
                @foreach ($songs as $song)
                <div class="col-xl-6">
                    <div class="list__item">
                        <div class="list__cover">
                            <img src="{{ $song->picture }}" alt="Hình" />
                            <a href="javascript:void(0);" class="btn btn-play btn-sm btn-default btn-icon rounded-pill" data-play-id="{{ $song->id }}" aria-label="Play pause">
                                <i class="fal fa-play"></i> <i class="fal fa-pause"></i>
                            </a>
                        </div>
                        <div class="list__content">
                            <a href="#" class="list__title text-truncate">{{ $song->name }}</a>
                            <p class="list__subtitle text-truncate"><a href="#">{{ $song->singers->name }}</a></p>
                        </div>
                        <ul class="list__option">
                            <li>
                                <a href="javascript:void(0);" role="button" class="d-inline-flex" aria-label="Favorite" data-favorite-id="1">
                                    <i class=""></i> <i class="ri-heart-fill heart-fill"></i>
                                </a>
                            </li>

                            <li class="dropstart d-inline-flex">
                                <a class="dropdown-link" href="javascript:void(0);" role="button" data-bs-toggle="dropdown" aria-label="Cover options" aria-expanded="false"><i class="fas fa-ellipsis-h-alt"></i></a>
                                <ul class="dropdown-menu dropdown-menu-sm">
                                    <li><a class="dropdown-item" href="javascript:void(0);" role="button" data-play-id="{{ $song->path }}">Play</a></li>
                                    <li>
                                        <a href="{{ route('song.edit', $song->id) }}">
                                        <button type='submit' class='btn bg-yellow    btn-flat'  name=''>Sửa</button>
                                        </a>
                                        <form action="{{ route('song.destroy', $song->id) }}" method="POST" onclick="return confirm('Are you sure?')">
                                        @csrf
                                        @method('DELETE')
                                        <button type='submit' class='btn bg-red btn-flat'>Xóa</button></a>
                                        </form>
                                    </li>
                                </ul>



                            </li>
                        </ul>
                    </div>

                </div>
                @endforeach
            </div>
        </div>
        <div class="mt-5 text-center" style="margin-right:50%">

                   {{ $songs->links()  }}


        </div>
    </div>
</div>
@endsection